<?php

class MinibrowserHiSelector extends HiSelector {

 var $d_minibrowser;
 var $d_isNew = TRUE;

 function MinibrowserHiSelector(&$mbwrapper, $label = NULL, $popup = true) {
 if (is_a($label, "FormComponent")) {
 $component = $label;
 } else {
 $component = new TextComponent($label);
 }
 parent::HiSelector( $component, !$popup );
 $this->setOptional(true);
 $this->d_minibrowser =& $mbwrapper;
 $c =& $this->getFormComponent();
 $this->initComponent();
 $c->addUserField( "u_type", "Tree-T-Type" );
 $c->addUserField( "u_id", "Tree-ID" );
 $c->addUserField( "u_obj_type", "Object-T-Type" );
 $c->addUserField( "u_obj_id", "Object-ID" );
 }

 function initComponent() {
 $c =& $this->getFormComponent();
 $c->setText($this->d_minibrowser->getText());
 }

 function setFolder($id, $type) {
 $mb =& $this->d_minibrowser->getMinibrowser();
 $mb->setFolder($id, $type);
 }

 function getFolderID() {
 $mb =& $this->d_minibrowser->getMinibrowser();
 return $mb->getFolderID();
 }

 function getFolderType() {
 $mb =& $this->d_minibrowser->getMinibrowser();
 return $mb->getFolderType();
 }

 function setResult($step, $value) {
 $mb =& $this->d_minibrowser->getMinibrowser();
 $mb->setResultID($step, $value);
 }

 function getResult($step = false) {
 $mb =& $this->d_minibrowser->getMinibrowser();
 return $mb->getResultID($step);
 }


 function &getResultObject() {
 return $this->d_minibrowser->getResultObject();
 }

 function setObject(&$obj) {
 parent::setObject($obj);
 $this->d_minibrowser->setObject($obj);
 }

 function reset() {
 parent::reset();
 }

 function onLoadFinished(&$form)
 {
 parent::onLoadFinished($form);
 $this->updateMiniBrowser($form);
 if( !$this->isOptional() ) {
 $result = $this->getResultObject();
 if( $result === null || (is_a($result, 'nodeobject') && $result->isNew()) ) {
 $this->addError( new NodeException( i18n( 'Please make a selection.' ) ) );
 }
 }
 }
 function updateMiniBrowser(&$form)
 {
 $c = &$this->getFormComponent();
 $mb = &$this->d_minibrowser->getMiniBrowser();
 $mb->setFolder( $c->getFieldValue("u_id"), $c->getFieldValue("u_type") );
 $this->d_minibrowser->initObject($c->getFieldValue('u_obj_type'), $c->getFieldValue('u_obj_id') );
 }
 
 function handleSelection() {
 $this->d_isNew = FALSE; 
 $mb =& $this->d_minibrowser->getMinibrowser();

 if ($mb->isSubmit()) {
 $mb->initFromSubmit();
 } else {
 $mb->resetFinished();
 }

 if (($finished = $mb->isFinished()) || $mb->isCancelled()) {
 
 if ($finished) {
 $c =& $this->getFormComponent();
 $c->setText($this->d_minibrowser->getText());
 $mb = &$this->d_minibrowser->getMiniBrowser();
 $c->setFieldValue( "u_type", $mb->getFolderType() );
 $c->setFieldValue( "u_id", $mb->getFolderID() );
 $c->setFieldValue( "u_obj_type", $this->d_minibrowser->getObjectType() );
 $c->setFieldValue( "u_obj_id", $this->d_minibrowser->getObjectID() );
 }
 
 return true;
 }

 $urlAdd = $this->getHiddenValuesURLStr();
 $mb->setLinkParams($urlAdd);
 $out = $mb->getHTML();
 return $out;
 }

 function &getProperty( $key ) {
 $ret =& parent::getProperty( $key );
 if ( !is_a( $ret, "emessage" ) && is_object( $ret ) ) return $ret;
 $class = $this->getResultObject();
 return $class->getProperty( $key );
 }

 function toString() {
 $c =& $this->getFormComponent();
 return $c->toString();
 }
 
 function getSerializeKey() 
 {
 $ret = parent::getSerializeKey();
 $ret["MinibrowserHiSelector§"] = array("mini"=>node_serialize($this->d_minibrowser) );
 return $ret;
 }
 
 function initFromSerializeKey( $sKey ) 
 {
 node_class("minibrowser");
 node_var("T_TYPE");
 parent::initFromSerializeKey($sKey);
 $key = $sKey["MinibrowserHiSelector§"];
 $this->d_minibrowser = &node_unserialize($key["mini"]);
 }
 
 function &getWrapper() {
 return $this->d_minibrowser;
 }

 


 function clearSelection() {
 parent::clearSelection();
 $c =& $this->getFormComponent();
 $c->setFieldValue("u_type", "");
 $c->setFieldValue("u_id", "");
 $c->setFieldValue("u_obj_type", "");
 $c->setFieldValue("u_obj_id", "");
 }
}

class ObjectSelectionMinibrowser extends MinibrowserHiSelector {


 function ObjectSelectionMinibrowser(&$mbwrapper, $label = NULL, $popup = true) {
 parent::MinibrowserHiSelector($mbwrapper, $label, $popup);
 $this->d_minibrowser->createMinibrowser();
 }

 function initComponent() {
 }

 function updateMiniBrowser(&$form) { }

 function handleSelection() {
 $this->d_isNew = FALSE; 
 $mb =& $this->d_minibrowser->getMinibrowser();

 if ($mb->isSubmit()) {
 $mb->initFromSubmit();
 } else {
 $mb->resetFinished();
 }

 if (($finished = $mb->isFinished()) || $mb->isCancelled()) {
 $ret = null;
 
 if ($finished) {
 $c =& $this->getFormComponent();
 
 $ret = $c->setObject($this->d_minibrowser->getResultObject());
 
 
 $mb = &$this->d_minibrowser->getMiniBrowser();
 $c->setFieldValue( "u_type", $mb->getFolderType() );
 $c->setFieldValue( "u_id", $mb->getFolderID() );
 $c->setFieldValue( "u_obj_type", $this->d_minibrowser->getObjectType() );
 $c->setFieldValue( "u_obj_id", $this->d_minibrowser->getObjectID() );
 }
 if( $ret !== "noclose" )
 return true;
 }

 $urlAdd = $this->getHiddenValuesURLStr();
 $mb->setLinkParams($urlAdd);
 $out = $mb->getHTML();
 return $out;
 }

 function _showOpenIcon() {
 return false;
 }
}
?>
