<?php

function cmd_insert_cell($cells, $nr, $direction, $tag_id, $tag_type) {
 $tag_type = sqlf_name($tag_type);

 $tag = get_taginfo($tag_id, $tag_type, "tab");
 if (!$tag["name"]) halt(7, "cmd_insert_cell: get_taginfo[name] empty. tag_id($tag_id) tag_type($tag_type)");
 $d_rows = $tag["detail"]["rows"];
 $d_cols = $tag["detail"]["cols"];
 $name = $tag["name"]; 
 $o_id = $tag["o_id"]; 
 $t_cid = $tag["cid"]; 
 $t_pid = $tag["detail"]["pid"];
 $t_enabled = $tag["enabled"];
 $t_pub = $tag["pub"];
 $tagkey = get_tagkey($tag_type);
 $sqlpart = $tagkey["sql"];

 $rs = get_tablesize($tag_type,$name);
 $rows = $rs["rows"];
 $cols = $rs["cols"];
 if ($cols > 26) $cols = 26;

 
 $sql = "SELECT id FROM part WHERE construct_id = ".sqlf_tl_num($t_cid)." AND part.keyword LIKE 'tr.%'";
 $rs = query($sql);
 
 
 while (list($key,$val) = each($rs["arr"])) {
 $tr_parts[$val["id"]] = true;
 }
 $sql = "SELECT id FROM part WHERE construct_id = ".sqlf_tl_num($t_cid)." AND part.keyword LIKE 'td.%'";
 $rs = query($sql);
 
 while (list($key,$val) = each($rs["arr"])) {
 $td_parts[$val["id"]] = true;
 }

 
 krsort($cells);
 if (is_array($cells))
 while (list($item, $v) = each($cells)) {
 
 if (is_numeric($item)) {
 $kind = "row";
 
 if ($direction == 1 ) $start = $item+1;
 else if ($direction == -1) $start = $item;
 else halt( 7, "cmd_insert_cell: invalid direction ($direction)");
 
 $sql = "SELECT id FROM ".$tag_type."tag WHERE name = '".sqlf_escaped("$name.$item.style")."' AND $sqlpart";
 $rs = query($sql);
 $orig_tr_style = $rs["arr"][0]["id"];
 $orig_td_style = array();
 $cid = array();
 $enabled = array();
 for ($i = 1; $i <= $d_cols; $i++) {
 $insname = chr(64 + $i).$item;
 $sql = "SELECT id, construct_id, enabled FROM ".$tag_type."tag WHERE name = '".sqlf_escaped("$name.$insname.style")."' AND $sqlpart";
 $rs = query($sql);
 $orig_td_style[$i] = ($rs["arr"][0]["id"])?$rs["arr"][0]["id"]:0;
 $sql = "SELECt id, construct_id, enabled FROM ".$tag_type."tag WHERE name = '".sqlf_escaped("$name.$insname")."' AND $sqlpart";
 $rs = query($sql);
 $cid[$i] = ($rs["arr"][0]["construct_id"])?$rs["arr"][0]["construct_id"]:1;
 
 if ($tag["detail"]["cid"]) { $cid[$i] = $tag["detail"]["cid"]; }
 $enabled[$i] = ($rs["arr"][0]["enabled"])?$rs["arr"][0]["enabled"]:1;
 }
 
 for ($j = $rows; $j >= $start; $j--) {
 $sql = "UPDATE ".$tag_type."tag SET name = '".sqlf_escaped("$name.".($j+$nr).".style")."' WHERE name = '".sqlf_escaped("$name.$j.style")."' AND $sqlpart";
 query($sql);
 for ($i = 1; $i <= $cols ; $i++) {
 $old_name = chr(64 + $i).$j;
 $new_name = chr(64 + $i).($j + $nr);
 $sql = "UPDATE ".$tag_type."tag SET name = '".sqlf_escaped("$name.$new_name")."' WHERE name = '".sqlf_escaped("$name.$old_name")."' AND $sqlpart";
 query($sql);
 $sql = "UPDATE ".$tag_type."tag SET name = '".sqlf_escaped("$name.$new_name.style")."' WHERE name = '".sqlf_escaped("$name.$old_name.style")."' AND $sqlpart";
 query($sql);
 }
 }
 
 for ($j = $start; $j < $start+$nr; $j++) {
 
 $sql = "SELECT id FROM ".$tag_type."tag WHERE name = '".sqlf_escaped("$name.$j.style")."' AND $sqlpart";
 $rs = query($sql);
 if ($rs["arr"][0]["id"]) tag_del($rs["arr"][0]["id"],$tag_type);
 if ($orig_tr_style) tag_duplicate($orig_tr_style,$tag_type,0,"$name.$j.style");
 else {
 tag_create("$name.$j.style", $o_id, $tag_type, $t_cid, $t_pub, $t_enabled, $tag_id, $tr_parts);
 }
 
 for ($i = 1; $i <= $d_cols ; $i++) {
 $ins_name = chr(64 + $i).$j;
 
 $sql = "SELECT id FROM ".$tag_type."tag WHERE name = '".sqlf_escaped("$name.$ins_name")."' AND $sqlpart";
 $rs = query($sql);
 if ($rs["arr"][0]["id"]) tag_del($rs["arr"][0]["id"],$tag_type);
 tag_create("$name.$ins_name", $o_id, $tag_type, $cid[$i], $t_pub, $enabled[$i], $tag_id);
 
 $sql = "SELECT id FROM ".$tag_type."tag WHERE name = '".sqlf_escaped("$name.$ins_name.style")."' AND $sqlpart"; 
 $rs = query($sql);
 if ($rs["arr"][0]["id"]) tag_del($rs["arr"][0]["id"],$tag_type);
 if ($orig_td_style[$i]) tag_duplicate($orig_td_style[$i],$tag_type,0,"$name.$ins_name.style");
 else tag_create("$name.$ins_name.style", $o_id, $tag_type, $t_cid, $t_pub, $t_enabled, $tag_id, $td_parts);
 }
 }
 $d_rows += $nr;
 $rows += $nr;
 
 } else {
 
 $item = ord($item) - 64;
 if ($direction == 1 ) $start = $item+1;
 else if ($direction == -1) $start = $item;
 else halt ( 7, "cmd_insert_cell: invalid direction ( $direction)");
 
 $orig_td_style = array();
 $cid = array();
 $enabled = array();
 for ($i = 1; $i <= $d_rows; $i++) {
 $insname = chr(64 + $item).$i;
 $sql = "SELECT id, construct_id, enabled FROM ".$tag_type."tag WHERE name = '".sqlf_escaped("$name.$insname.style")."' AND $sqlpart";
 $rs = query($sql);
 $orig_td_style[$i] = ($rs["arr"][0]["id"])?$rs["arr"][0]["id"]:0;
 $sql = "SELECt id, construct_id, enabled FROM ".$tag_type."tag WHERE name = '".sqlf_escaped("$name.$insname")."' AND $sqlpart";
 $rs = query($sql);
 $cid[$i] = ($rs["arr"][0]["construct_id"])?$rs["arr"][0]["construct_id"]:1;
 $enabled[$i] = ($rs["arr"][0]["enabled"])?$rs["arr"][0]["enabled"]:1;
 }
 
 for ($j = 1; $j <= $rows ; $j++) {
 for ($i = $cols; $i >= $start; $i--) {
 $old_name = chr(64 + $i).$j;
 $new_name = chr(64 + $i + $nr).$j;
 $sql = "UPDATE ".$tag_type."tag SET name = '".sqlf_escaped("$name.$new_name")."' WHERE name = '".sqlf_escaped("$name.$old_name")."' AND $sqlpart";
 query($sql);
 $sql = "UPDATE ".$tag_type."tag SET name = '".sqlf_escaped("$name.$new_name.style")."' WHERE name = '".sqlf_escaped("$name.$old_name.style")."' AND $sqlpart";
 query($sql);
 }
 }
 
 for ($i = $start; $i < $start+$nr; $i++) {
 
 
 
 for ($j = 1; $j <= $d_rows ; $j++) {
 $ins_name = chr(64 + $i).$j;
 
 $sql = "SELECT id FROM ".$tag_type."tag WHERE name = '".sqlf_escaped("$name.$ins_name")."' AND $sqlpart";
 $rs = query($sql);
 if ($rs["arr"][0]["id"]) tag_del($rs["arr"][0]["id"],$tag_type);
 tag_create("$name.$ins_name", $o_id, $tag_type, $cid[$j], $t_pub, $enabled[$j], $tag_id);
 
 $sql = "SELECT id FROM ".$tag_type."tag WHERE name = '".sqlf_escaped("$name.$ins_name.style")."' AND $sqlpart";
 $rs = query($sql);
 if ($rs["arr"][0]["id"]) tag_del($rs["arr"][0]["id"],$tag_type);
 if ($orig_td_style[$j]) tag_duplicate($orig_td_style[$j],$tag_type,0,"$name.$ins_name.style");
 else tag_create("$name.$ins_name.style", $o_id, $tag_type, $t_cid, $t_pub, $t_enabled, $tag_id, $td_parts);
 }
 }
 $d_cols += $nr;
 $cols += $nr;
 }
 
 
 cmd_update_value( implode(";",array($d_cols,$d_rows)), false, false, $tag_type, $tag_id, FALSE, $t_pid );
 

 }
}

function cmd_delete_cell($cells, $tag_id, $tag_type) {
 global $FEATURE;
 $tag_type = sqlf_name($tag_type);

 $tag = get_taginfo($tag_id, $tag_type, "tab");
 if (!$tag["name"]) halt(7, "cmd_insert_cell: get_taginfo[name] empty. tag_id($tag_id) tag_type($tag_type)");
 $d_rows = $tag["detail"]["rows"];
 $d_cols = $tag["detail"]["cols"];
 $name = $tag["name"]; 
 $t_cid = $tag["cid"];
 $t_pid = $tag["detail"]["pid"];
 $tagkey = get_tagkey($tag_type);
 $sqlpart = $tagkey["sql"];

 $rs = get_tablesize($tag_type, $name);
 $rows = $rs["rows"];
 $cols = $rs["cols"];
 if ($cols > 26) $cols = 26;

 
 krsort($cells);
 if (is_array($cells))
 while (list($item, $v) = each($cells)) {
 
 if (is_numeric($item)) {
 
 for ($i = 1; $i <= $cols ; $i++) {
 $del_name = chr(64 + $i).$item;
 $sql = "SELECT id FROM ".$tag_type."tag WHERE name = '".sqlf_escaped("$name.$del_name")."' AND $sqlpart";
 $rs = query($sql);
 if ($rs["arr"][0]["id"]) tag_del($rs["arr"][0]["id"],$tag_type);
 }
 
 for ($j = $item + 1; $j <= $rows; $j++) {
 for ($i = 1; $i <= $cols ; $i++) {
 $old_name = chr(64 + $i).$j;
 $new_name = chr(64 + $i).($j - 1);
 $sql = "UPDATE ".$tag_type."tag SET name = '".sqlf_escaped("$name.$new_name")."' WHERE name = '".sqlf_escaped("$name.$old_name")."' AND $sqlpart";
 query($sql);
 }
 }
 $rows--;
 $d_rows--;
 
 } else {
 $item = ord($item) - 64;
 
 for ($j = 1; $j <= $rows ; $j++) {
 $del_name = chr(64 + $item).$j;
 $sql = "SELECT id FROM ".$tag_type."tag WHERE name = '".sqlf_escaped("$name.$del_name")."' AND $sqlpart";
 $rs = query($sql);
 if ($rs["arr"][0]["id"]) tag_del($rs["arr"][0]["id"],$tag_type);
 }
 
 for ($i = $item + 1; $i <= $cols; $i++) {
 for ($j = 1; $j <= $rows ; $j++) {
 $old_name = chr(64 + $i).$j;
 $new_name = chr(64 + $i - 1).$j;
 $sql = "UPDATE ".$tag_type."tag SET name = '".sqlf_escaped("$name.$new_name")."' WHERE name = '".sqlf_escaped("$name.$old_name")."' AND $sqlpart";
 query($sql);
 }
 }
 $cols--;
 $d_cols--;
 }
 
 
 $val_text = implode(";",array($d_cols,$d_rows));
 cmd_update_value( $val_text, false, false, $tag_type, $tag_id, FALSE, $t_pid );
 

 } 
}

function cmd_cell_move($cells, $nr, $direction, $_max, $tag_id, $tag_type, $dostyles = false) {

 if ($direction != -1 && $direction != 1 && $direction != -2 && $direction != 2) halt(7,"function cell_move: unkown direction ($direction)");
 $min = 1;
 $max = $_max;
 if ($direction > 0) krsort($cells);
 else ksort($cells);
 
 if ($direction == 2) {
 $nr = $max;
 $direction = 1;
 }
 
 if ($direction == -2) {
 $nr = $max;
 $direction = -1;
 }

 $tag = get_taginfo($tag_id, $tag_type, "tab");
 $tag_type = sqlf_name($tag["type"]);
 if (!$tag["name"]) halt(7,"switch_tab: get_taginfo[name] empty. tag_id($tag_id) tag_type($tag_type)");
 $d_rows = $tag["detail"]["rows"];
 $d_cols = $tag["detail"]["cols"];
 $name = $tag["name"];
 $tagkey = get_tagkey($tag_type);
 $sqlpart = $tagkey["sql"];
 
 while (list($k, $v) = each($cells)) {
 if (!is_numeric($k)) { $start = ord($k) - 64; $max = $d_cols; }
 else { $start = $k; $max = $d_rows; }

 $_nr = ($direction == 1)?min($nr, $max - $start):min($nr, $start - 1);
 for ($i = 0; $i < $_nr; $i++) {
 $mod = ($direction < 0 ? 1 : -1);
 $_k = $start + $i * $direction;
 if (is_numeric($k)) {
 
 $actual_row = $_k;
 for ($col = 1; $col <= $d_cols; $col++) {
 $source_cell = chr($col + 64) . $actual_row;
 $target_cell = chr($col + 64) . ($actual_row - $mod);
 
 $sql = "UPDATE " . $tag_type . "tag SET name = '".sqlf_escaped("$name.!$target_cell")."' WHERE name = '".sqlf_escaped("$name.$target_cell")."' AND $sqlpart";
 query($sql);
 
 $sql = "UPDATE " . $tag_type . "tag SET name = '".sqlf_escaped("$name.$target_cell")."' WHERE name = '".sqlf_escaped("$name.$source_cell")."' AND $sqlpart";
 query($sql);
 
 $sql = "UPDATE " . $tag_type . "tag SET name = '".sqlf_escaped("$name.$source_cell")."' WHERE name = '".sqlf_escaped("$name.!$target_cell")."' AND $sqlpart";
 query($sql);
 }
 } else {
 
 $actual_col = chr($_k + 64);
 for ($row = 1; $row <= $d_rows; $row++) {
 $source_cell = $actual_col . $row;
 $target_cell = chr(ord($actual_col) - $mod) . $row;
 
 $sql = "UPDATE " . $tag_type . "tag SET name = '".sqlf_escaped("$name.!$target_cell")."' WHERE name = '".sqlf_escaped("$name.$target_cell")."' AND $sqlpart";
 query($sql);
 
 $sql = "UPDATE " . $tag_type . "tag SET name = '".sqlf_escaped("$name.$target_cell")."' WHERE name = '".sqlf_escaped("$name.$source_cell")."' AND $sqlpart";
 query($sql);
 
 $sql = "UPDATE " . $tag_type . "tag SET name = '".sqlf_escaped("$name.$source_cell")."' WHERE name = '".sqlf_escaped("$name.!$target_cell")."' AND $sqlpart";
 query($sql);
 }
 }
 





 }
 }
}


function cmd_switch_tab($item, $direction, $tag_id, $tag_type) {

$tag = get_taginfo($tag_id, $tag_type, "tab");
$tag_type = $tag["type"];
if (!$tag["name"]) halt(7,"switch_tab: get_taginfo[name] empty. tag_id($tag_id) tag_type($tag_type)");
$d_rows = $tag["detail"]["rows"];
$d_cols = $tag["detail"]["cols"];
$name = $tag["name"];
$tagkey = get_tagkey($tag_type);
$sqlpart = $tagkey["sql"];

$rs = get_tablesize($tag_type,$name);
$rows = $rs["rows"];
$cols = $rs["cols"];
if ($cols > 26) $cols = 26;

if (is_numeric($item)) {
 $kind = "row";
 $from = $item;
 $to = $item + $direction;
 $max = $cols;
 if ($from > $rows || $from < 1) halt(7,"switch_tab: invalid from($from) or to($to)");
} else {
 $kind = "col";
 $from = $item;
 $to = chr(ord($item) + $direction);
 $max = $rows;
 if ((ord($to) - 64) > $cols || (ord($to) - 64) < 1) halt(7,"switch_tab: invalid from($from) or to($to)");
}


for ($i = 1; $i <= $max; $i++) {
 if ($kind == "row") {
 $source_cell = chr($i+64).$from;
 $target_cell = chr($i+64).$to;
 }
 if ($kind == "col") {
 $source_cell = $from.$i;
 $target_cell = $to.$i;
 }
 $tag_type = sqlf_name($tag_type);
 
 
 $sql = "UPDATE ".$tag_type."tag SET name = '".sqlf_escaped("$name.!$target_cell")."' WHERE name = '".sqlf_escaped("$name.$target_cell")."' AND $sqlpart";
 query($sql);
 
 $sql = "UPDATE ".$tag_type."tag SET name = '".sqlf_escaped("$name.$target_cell")."' WHERE name = '".sqlf_escaped("$name.$source_cell")."' AND $sqlpart";
 query($sql);
 
 $sql = "UPDATE ".$tag_type."tag SET name = '".sqlf_escaped("$name.$source_cell")."' WHERE name = '".sqlf_escaped("$name.!$target_cell")."' AND $sqlpart";
 query($sql);
}
 

}

?>
