<?php

if( !$ctag_page_id ) $ctag_page_id = $PAGE_ID;

GUIFactory::setMainGUI("main");
load_menu(14004,$T_PAGE,$ctag_page_id,i18n("Versions").get_contentgroup_ass(), 1, $DO);


$is_locked = is_locked($ctag_page_id, "page");














class TextSource extends PlainColumnSource
{
 var $m_text = "";

 function TextSource( $text ) {
 $this->m_text = $text;
 }

 function getContent( $rs ) {
 return $this->m_text;
 }
}

class VersiondiffSource extends PlainColumnSource {
 var $m_text = "";
 var $checktimestamp = "";

 function VersiondiffSource( $text, $checktimestamp ) {
 $this->m_text = $text;
 $this->checktimestamp = $checktimestamp;
 }

 function getContent( $rs ) {
 if ($rs["date.timestamp"] == $this->checktimestamp) {
 return false;
 } else {
 return $this->m_text;
 }
 }
}

class NoDateFormatter extends ResultSetFormatter
{
 function format( $rs )
 {
 if ( $rs["date.timestamp"] == 0 )
 return i18n( "First Version" );
 return $rs["date"];
 }
}

class VersionDiffAction extends GenericAction {
 var $versions;
 var $checktimestamp = "";

 function VersionDiffAction($icon, $name, $description, $versions, $checktimestamp) {
 $this->GenericAction($icon, $name, $description);
 $this->versions = $versions;
 $this->checktimestamp = $checktimestamp;
 }

 function performAction( $idList ) {
 global $JS, $REDO, $firstdate, $lastdate, $diffsource;
 if ( sizeof($idList) == 1) {
 
 if ($idList[0] == $this->checktimestamp) {
 
 $JS .= "alert('".i18n("versiondiff_not_first_version")."')";
 } else {
 
 $firstdate = $idList[0] - 1;
 $lastdate = $idList[0];
 $diffsource = "0";
 $REDO = 14016;
 }
 } else if (sizeof($idList) != 2) {
 $JS .= "alert('".i18n("versiondiff_select_two_versions")."');";
 } else {
 $firstdate = $idList[0];
 $lastdate = $idList[1];
 $diffsource = "0";
 $REDO = 14016;
 }
 }
}

$o_page = new CNPageObject($ctag_page_id);

if ($cmd == 'restore') {
 $editable = lock($ctag_page_id,"page");
 if ( !$FEATURE["tuning_pagesave"] ) {
 page_status($ctag_page_id,0);
 }

 if (!$editable) {
 $JS = "alert('".i18n('this_page_is_currently')."');\n";
 $REDO = 14001;
 return;
 }

 $o_page->restore($vdate);

 $REDO = 14001;
} else {
 
 if ($cmd == 'preview') {
 $JS = "\ngo_openwindow('$STAG&do=14001&live=$ctag_page_id&version=$vdate');\n";
 }

 node_class("arraydatasource");
 node_class("dateformatter");
 node_class("userformatter");

 $versions = $o_page->getProperty("versions");
 
 
 if ($FEATURE["versiondiff"]) {
 $ds = new NodeCollectionDataSource($versions,Array("version"=>i18n("Version"),"date"=>i18n("Date"),"user.name"=>i18n("User"),"lpreview"=>i18n("Preview"),"lrestore"=>i18n("Restore")));
 } else {
 $ds = new NodeCollectionDataSource($versions,Array("version"=>i18n("Version"),"date"=>i18n("Date"),"user.name"=>i18n("User"),"lrestore"=>i18n("Restore")));
 }
 $ds->setProperties(Array("date","date.timestamp","user.name","version"));
 
 
 $ds->makeLink("lpreview", "prev", "do=10030&cmd=preview", "", "vdate", "date.timestamp");
 $ds->makeLink("lrestore", "rest", "do=10030&cmd=restore", "", "vdate", "date.timestamp");
 $ds->addSourceColumn("prev","",new TextSource(i18n("preview")),false);
 $ds->addSourceColumn("rest","",new TextSource(i18n("restore")),false);
 $ds->setIdProperty("date.timestamp");
 if ($FEATURE["versiondiff"]) {
 $ds->makeLink("ldiff", "diff", "do=10030&cmd=diff", "", "firstdate", "date.timestamp", "diff");
 $firsttimestamp = resolveProperty("date.timestamp", $versions->get(0));
 $ds->addSourceColumn("diff", "", new VersiondiffSource(i18n("versiondiff"), $firsttimestamp->toString()), false);
 $ds->addAction(new VersionDiffAction($ICO_VERSIONDIFF, "diff", i18n("versiondiff"), $versions, $firsttimestamp->toString()));
 }
 $lst = new ItemList3("versions",$ds);
}

$JS .= "
function cn3_onPageSaved() {
	progress( top.menu );
    self.location.href = self.location.href;
}
";

?>
