<?php
GUIFactory::setMainGUI("main");

node_include('htmlform3');
node_include('textcomponent');
node_include('labelcomponent');
node_include('generic_action');
node_include('itemlistcomponent');
node_include('item_list_arrayds');
node_include('validation');
node_include('msg');
node_include('page_status');
node_include('functional');
node_include('user');

class AssignPagesAction extends GenericAction {

 function AssignPagesAction($icon, $name, $description, $redo_str) {
 parent::GenericAction($icon, $name, $description);
 
 }

 function performAction($idList, $ds) {
 
 
 
 
 
 
 global $ASSIGN_USERS;
 $ASSIGN_USERS = $idList;
 
 
 
 
 global $REDO_STR;
 $REDO_STR = 'do=16003';
 }
}

$page_ids = determine_pages_to_assign();
$redo_str = determine_submit_redo();


$REDO_STR = null;


$ASSIGN_USERS = null;



$ASSIGN_FORM = create_assign_form($page_ids, $redo_str);


if ( ! empty($ASSIGN_USERS) ) {
 if ( ! assign_users($ASSIGN_FORM, $ASSIGN_USERS) ) {
 
 
 
 
 unset($REDO_STR);
 }
}

if ( ! is_null($REDO_STR) ) {
 
 
 
 $ASSIGN_FORM->_buildFormFooter();

 
 
 

 perform_redo($REDO_STR);
}

return;






function unlock_pages_to_assign($page_ids) {
 
 
 
 if ($_REQUEST['pubqueue_assign_unlock']) {
 node_include('lock');
 foreach ($page_ids as $page_id) {
 unlock($page_id, 'page');
 }
 }
}







function perform_redo($redo_str) {
 parse_str($redo_str, $redo);
 
 global $REDO;
 $REDO = $redo['do'];
}

function determine_submit_redo() {
 $redo_str = $_REQUEST['pubqueue_assign_submit_redo'];
 if (is_null($redo_str)) {
 
 $redo_str = 'do=16003';
 }
 return $redo_str;
}

function determine_pages_to_assign() {
 $page_id = $_REQUEST['pubqueue_assign_page_id'];
 if ( ! is_null($page_id) ) {
 
 
 return array($page_id);
 } else {
 
 
 global $PUBQUEUE_ITEMS;
 return $PUBQUEUE_ITEMS;
 }
}







function create_assign_form($page_ids, $redo_str) {
 global $ICO_PUBQUEUE, $ICO_PAGE, $ICO_CHECK_ALL;

 $form = new HtmlForm3('pubqueue_assign');

 
 
 $form->addHeader('<style type="text/css">
    #pubqueue_assign_page_list {
        list-style: none; }
    #pubqueue_assign_page_list li {
        background-image: url("' . addslashes($ICO_PAGE) . '");
        background-repeat: no-repeat;
        background-position: left;
        margin-top: 4px;
        line-height: 18px;
        padding-left: 24px; }
    </style>');

 if ( ! $form->isNew() ) {
 return $form;
 }

 
 check_pubqueue_assign_perms($page_ids);

 
 
 

 
 $form->setHeader(i18n("pubqueue.assign.header"), $ICO_PUBQUEUE);

 $page_store = create_page_store($page_ids);
 $page_list_comp = create_page_list_comp($page_ids);
 $user_list_comp = create_user_list_comp($page_ids);
 $message_comp = create_message_comp($page_ids);

 $form->addComponent("page_store", $page_store);
 $form->addComponent("page_list", $page_list_comp);
 $form->addComponent("user_list", $user_list_comp);
 $form->addComponent("message", $message_comp);

 $custom_params = array("redo_str" => $redo_str);
 $form->addButton("cancel", new Button(i18n("Cancel"), false), new SimpleFormAction("cancel_assign", $custom_params), false);
 $form->addButton("ok", new Button(i18n("ok"), false), new SimpleFormAction("ok_assign", $custom_params), true);
 return $form;
}







function create_page_store($page_ids) {

 $pages = array();
 foreach ($page_ids as $page_id) {
 $pages[] = array("id" => $page_id);
 }

 $page_store_ds = new ArrayDataSource($pages, array());
 $page_store = new ItemList3("page_store", $page_store_ds);
 $page_store_comp = new ItemListComponent("", $page_store);
 $page_store_comp->setHidden(true);
 return $page_store_comp;
}

function create_page_list_comp($page_ids) {
 global $ICO_PAGE;
 $page_list = '<ul id="pubqueue_assign_page_list">';
 foreach ($page_ids as $page_id) {
 $page_info = get_pageinfo($page_id);
 $page_list .= '<li><span class="pubqueue_assign_list_item">' . $page_info['name'] . '</span></li>';
 }
 $page_list .= '</ul>';
 $page_list_comp = new LabelComponent(i18n("pubqueue.assign.pagelist.label"), $page_list, true);
 return $page_list_comp;
}

function create_user_list_comp($page_ids, $redo_str) {
 global $FEATURE;

 $visible_users = array();
 foreach (user_get_visibleuserswithname() as $user) {
 
 if (-1 == $user["id"]) {
 continue;
 }

 
 
 $name = $user["lastname"];
 if ($FEATURE["pubqueue_email"] && $user["email"]) {
 $name .= ' &lt;' . $user["email"] . '&gt;';
 }

 $visible_users[] = array(
 "id" => $user["id"],
 "icon" => $user["icon"],
 "name" => $name
 );
 }

 $cols = array(
 'icon' => '',
 'name' => i18n("pubqueue.assign.userlist.name")
 );
 $icon = null;
 $assign_action = new AssignPagesAction($icon, "assign", i18n("pubqueue.assign.action"), $redo_str);
 $user_list_ds = new ArrayDataSource($visible_users, $cols);
 $user_list_ds->setAction($assign_action);

 
 
 $user_list_ds->setSearchable(true);

 
 
 
 $pre_selected = array();
 foreach ($page_ids as $page_id) {
 $page_info = get_pageinfo($page_id);
 $pre_selected[$page_info["editor"]] = true;
 }
 $user_list_ds->setPreSelected($pre_selected);

 $user_list = new ItemList3("user_list", $user_list_ds);

 
 
 global $ITEMLIST_NOPAGING_PAGESIZE;
 $user_list->setMaxListItems($ITEMLIST_NOPAGING_PAGESIZE);

 
 $potential_editors = gcn_array_column($visible_users, "id");
 $first_editor_offset = null;
 foreach ($pre_selected as $editor => $unused) {
 $editor_offset = array_search($editor, $potential_editors);
 if (is_null($first_editor_offset) || $editor_offset < $first_editor_offset) {
 $first_editor_offset = $editor_offset;
 }
 }
 
 
 if ( ! is_null($first_editor_offset) ) {
 $curr_page = floor($first_editor_offset / $user_list->getMaxListItems());
 $user_list->setCurrentPage($curr_page);
 }

 $user_list_comp = new ItemListComponent(i18n("pubqueue.assign.userlist.label"), $user_list);
 $user_list_comp->setHelp(i18n("pubqueue.assign.userlist.help"));
 return $user_list_comp;
}

function create_message_comp($page_ids) {
 $editable = true;
 $initial_value = "";
 $optional = false;
 $rows = 10;
 $cols = 20;
 $message_comp = new TextAreaComponent(
 i18n("pubqueue.assign.message.label"),
 $editable,
 $initial_value,
 REG_TEXT,
 $optional,
 $rows,
 $cols 
 );
 $message_comp->setHelp(i18n("pubqueue.assign.message.help"));
 $message_comp->setOptional(true);
 return $message_comp;
}

function make_assignment_message($page_ids, $user_message) {
 if (1 < count($page_ids)) {
 $page_list = '';
 foreach ($page_ids as $page_id) {
 $page_id = (int)$page_id;
 $page_list .= "<pageid $page_id>\n";
 }
 $system_message = i18n("pubqueue.assign.message.multiple", 0, $page_list);
 } else {
 $page_id = array_shift($page_ids);
 $page_id = (int)$page_id;
 $system_message = i18n("The page <pageid {0}> has been taken into revision.", 0, $page_id);
 }
 if ("" !== $user_message) {
 $system_message = rtrim($system_message);
 $system_message .= "\n\n--\n\n";
 }
 return $system_message . $user_message;
}




function cancel_assign($form, $custom_params) {
 global $REDO_STR;
 
 $REDO_STR = $custom_params["redo_str"];
}




function ok_assign($form, $custom_params) {

 $user_list_comp = $form->getComponent("user_list");
 $user_list = $user_list_comp->getList();
 $user_ids = $user_list->getSelection();

 if (assign_users($form, $user_ids)) {
 
 
 global $REDO_STR;
 
 
 $REDO_STR = $custom_params["redo_str"];
 }
}









function assign_users($form, $user_ids) {
 global $USER_ID;

 $page_store = $form->getComponent("page_store");
 $message_comp = $form->getComponent("message");

 $page_store_list = $page_store->getList();
 $page_store_ds = $page_store_list->getDatasource();
 $pages = $page_store_ds->getItems();
 $page_ids = gcn_array_column($pages, 'id');

 $message = $message_comp->getText();

 $resp = validate_input('userMessage', $message, new InputValidationRequest());
 $message = $resp->getCleanMarkup();
 if ($resp->isError()) {
 $form->addError($resp->getFormattedError());
 return false;
 }

 
 check_pubqueue_assign_perms($page_ids);

 
 $ignore_user_abort = ignore_user_abort(true);

 unlock_pages_to_assign($page_ids);

 $assignment_message = make_assignment_message($page_ids, $message);
 foreach ($user_ids as $user_id) {
 msg($assignment_message, $user_id, $USER_ID);
 }

 foreach ($page_ids as $page_id) {
 
 
 $noUserMessage = true;
 page_status($page_id, 0, $USER_ID, false, $noUserMessage, false);
 }

 ignore_user_abort($ignore_user_abort);
 return true;
}

function check_pubqueue_assign_perms($page_ids) {
 
 
 foreach ($page_ids as $page_id) {
 if ( ! perm_can_edit_page($page_id) ) {
 
 
 halt(7, "no edit perms to set page $page_id in work");
 }
 }
}


