<?php








function get_usageinfo_sql($type, $objs, $source_type, $do_select_folder_id = false) {
 global $T_FILE, $T_IMAGE, $T_PAGE, $T_TEMPLATE, $T_FOLDER, $USAGE_PAGEUSAGE;
 
 if(count($objs) > 0) { 
 $ids = implode(",", sqlf_tl_num_array($objs));
 } else {
 $ids = "-1";
 }

 if ($type == $T_FILE || $type == $T_IMAGE) {
 $part_types = "6, 8, 14";
 $ds_types = sqlf_tl_num($T_FILE).", ".sqlf_tl_num($T_IMAGE);
 } else if (strcmp($type, $T_PAGE . "_PAGETAGS") == 0 || strcmp($type, $T_TEMPLATE . "_PAGETAGS") == 0) {
 $part_types = "11";
 } else if ($type == $T_PAGE) {
 $part_types = "4";
 $ds_types = sqlf_tl_num($T_PAGE);
 } else {
 return false;
 }

 $folder_id_select = $do_select_folder_id ? ", page.folder_id" : "";
 if ($source_type == $T_PAGE && strcmp($type, $T_PAGE) == 0 && $USAGE_PAGEUSAGE) {
 
 $sql = "SELECT p1.id 
			FROM page 
			LEFT JOIN page p1 ON page.content_id = p1.content_id 
			WHERE p1.folder_id IS NOT NULL 
			AND page.id = ($ids) AND p1.id NOT IN ($ids)";
 } else if ($source_type == $T_PAGE && strcmp($type, $T_PAGE . "_PAGETAGS") == 0 && $USAGE_PAGEUSAGE) {
 
 $sql = "SELECT page.id $folder_id_select " .
 "FROM page " . 
 "INNER JOIN contenttag c1 ON page.content_id = c1.content_id " . 
 "INNER JOIN value v1 ON c1.id = v1.contenttag_id " . 
 "AND v1.value_text = 'p' AND v1.info IN ($ids)";
 } else if ($source_type == $T_TEMPLATE && strcmp($type, $T_TEMPLATE . "_PAGETAGS") == 0 && $USAGE_PAGEUSAGE) {
 
 $sql = "SELECT template.id " .
 "FROM template " .
 "INNER JOIN templatetag t1 ON template.id = t1.template_id " .
 "INNER JOIN value v1 ON t1.id = v1.templatetag_id AND v1.value_text = 'p' " .
 "INNER JOIN contenttag c2 ON v1.value_ref = c2.id " .
 "INNER JOIN page p2 ON c2.content_id = p2.content_id " .
 "WHERE p2.id IN ($ids)";
 } else if ($source_type == $T_PAGE) {
 
 $sql = "select distinct page.id $folder_id_select from page left join contenttag on " .
 "page.content_id = contenttag.content_id " .
 "left join value on contenttag.id = value.contenttag_id left join part " .
 "on value.part_id = part.id " .
 "where contenttag.enabled = 1 and part.type_id in ($part_types) and " .
 "value.value_ref in ($ids) " .
 "union distinct " . 
 "select distinct page.id $folder_id_select from page left join objtag on obj_type = ".sqlf_tl_num($T_PAGE)." " .
 "and obj_id = page.id " .
 "left join value on value.objtag_id = objtag.id left join part on " .
 "value.part_id = part.id " .
 "where objtag.enabled = 1 and part.type_id in ($part_types) and value_ref in ($ids) " .
 "union distinct " . 
 "select distinct page.id $folder_id_select from page left join contenttag on page.content_id = contenttag.content_id " .
 "left join ds on contenttag.id = ds.contenttag_id right join ds_obj on contenttag.id = ds_obj.contenttag_id " .
 "where ds_obj.o_id in ($ids) and ds.o_type in ($ds_types) " .
 "union distinct " . 
 "select distinct page.id $folder_id_select from page left join templatetag on " .
 "page.template_id = templatetag.template_id " .
 "left join ds on templatetag.id = ds.templatetag_id right join ds_obj on templatetag.id = ds_obj.templatetag_id " .
 "where ds_obj.o_id in ($ids) and ds.o_type in ($ds_types) " .
 "union distinct " . 
 "select distinct page.id $folder_id_select from page left join objtag on obj_type = ".sqlf_tl_num($T_PAGE)." " .
 "and obj_id = page.id " .
 "left join ds on objtag.id = ds.objtag_id right join ds_obj on objtag.id = ds_obj.objtag_id " .
 "where ds_obj.o_id in ($ids) and ds.o_type in ($ds_types)";
 } else if ($source_type == $T_TEMPLATE) {
 $folder_id_select = $do_select_folder_id ? ", template.folder_id" : "";
 
 $sql = "select distinct template.id $folder_id_select from template left join templatetag on " .
 "template.id = templatetag.template_id left join value on templatetag.id = value.templatetag_id " .
 "left join part on part.id = value.part_id where " .
 "templatetag.enabled = 1 and part.type_id in ($part_types) and value.value_ref in ($ids) " .
 "union distinct " . 
 "select distinct template.id $folder_id_select from template left join objtag on obj_type = ".sqlf_tl_num($T_TEMPLATE)." and obj_id = template.id " .
 "left join value on value.objtag_id = objtag.id left join part on " .
 "value.part_id = part.id " .
 "where objtag.enabled = 1 and part.type_id in ($part_types) and value_ref in ($ids) " .
 "union distinct " . 
 "select distinct template.id $folder_id_select from template left join templatetag on " .
 "template.id = templatetag.template_id " .
 "left join ds on templatetag.id = ds.templatetag_id right join ds_obj on templatetag.id = ds_obj.templatetag_id " .
 "where ds_obj.o_id in ($ids) and ds.o_type in ($ds_types) " .
 "union distinct " . 
 "select distinct template.id $folder_id_select from template left join objtag on obj_type = ".sqlf_tl_num($T_TEMPLATE)." and obj_id = template.id " .
 "left join ds on objtag.id = ds.objtag_id right join ds_obj on objtag.id = ds_obj.objtag_id " .
 "where ds_obj.o_id in ($ids) and ds.o_type in ($ds_types)";
 } else if ($source_type == $T_FOLDER) {
 
 $sql = "select distinct folder.id from folder left join objtag on obj_type = ".sqlf_tl_num($T_FOLDER)." and obj_id = folder.id " .
 "left join value on value.objtag_id = objtag.id left join part on value.part_id = part.id " .
 "where objtag.enabled = 1 and part.type_id in ($part_types) and value_ref in ($ids) " .
 "union distinct " . 
 "select distinct folder.id from folder left join objtag on obj_type = ".sqlf_tl_num($T_FOLDER)." and obj_id = folder.id " .
 "left join ds on objtag.id = ds.objtag_id right join ds_obj on objtag.id = ds_obj.objtag_id " .
 "where ds_obj.o_id in ($ids) and ds.o_type in ($ds_types)";
 } else if ($source_type == $T_FILE) {
 $folder_id_select = $do_select_folder_id ? ", contentfile.folder_id" : "";
 
 $sql = "select distinct contentfile.id $folder_id_select from contentfile left join objtag on obj_type = ".sqlf_tl_num($T_FILE)." and obj_id = contentfile.id " .
 "left join value on value.objtag_id = objtag.id left join part on value.part_id = part.id " .
 "where objtag.enabled = 1 and part.type_id in ($part_types) and value_ref in ($ids) " .
 "union distinct " . 
 "select distinct contentfile.id $folder_id_select from contentfile left join objtag on obj_type = ".sqlf_tl_num($T_FILE)." and obj_id = contentfile.id " .
 "left join ds on objtag.id = ds.objtag_id right join ds_obj on objtag.id = ds_obj.objtag_id " .
 "where ds_obj.o_id in ($ids) and ds.o_type in ($ds_types)";
 } else if ($source_type == $T_IMAGE) {
 $folder_id_select = $do_select_folder_id ? ", contentfile.folder_id" : "";
 
 $sql = "select distinct contentfile.id $folder_id_select from contentfile left join objtag on obj_type = ".sqlf_tl_num($T_IMAGE)." and obj_id = contentfile.id " .
 "left join value on value.objtag_id = objtag.id left join part on value.part_id = part.id " .
 "where objtag.enabled = 1 and part.type_id in ($part_types) and value_ref in ($ids) " .
 "union distinct " . 
 "select distinct contentfile.id $folder_id_select from contentfile left join objtag on obj_type = ".sqlf_tl_num($T_IMAGE)." and obj_id = contentfile.id " .
 "left join ds on objtag.id = ds.objtag_id right join ds_obj on objtag.id = ds_obj.objtag_id " .
 "where ds_obj.o_id in ($ids) and ds.o_type in ($ds_types)";
 }
 return $sql;
}







function get_page_usageinfo_count($page_id, $only_variants = false) {
 if (!$page_id) {
 return 0;
 }
 global $USAGE_PAGEUSAGE, $T_PAGE, $T_TEMPLATE, $PAGEUSAGE_MAXDURATION, $PAGEUSAGE_MAXDURATION_EXCEEDED;
 if ($PAGEUSAGE_MAXDURATION_EXCEEDED) {
 return -1;
 }
 $start = microtime_float();
 $usage_pageusage_oldvalue = $USAGE_PAGEUSAGE;
 $USAGE_PAGEUSAGE = true;
 $objs = array($page_id => $page_id);
 $count = 0;

 
 
 $sql = get_usageinfo_sql($T_PAGE, $objs, $T_PAGE);
 $res = query($sql);
 $count += $res["num"];

 if ($only_variants) {
 $USAGE_PAGEUSAGE = $usage_pageusage_oldvalue;
 if ((microtime_float() - $start) > $PAGEUSAGE_MAXDURATION) {
 $PAGEUSAGE_MAXDURATION_EXCEEDED = true;
 }
 return $count;
 }

 
 $sql = "select count(v.id) as c from value v where v.value_text = 'p' and v.info = ".sqlf_tl_num($page_id)." and (v.contenttag_id != 0 or v.templatetag_id != 0);";
 
 $rs = query($sql);
 $mycount = $rs['arr'][0]['c'];
 if( $mycount < 1 ) {
 if ((microtime_float() - $start) > $PAGEUSAGE_MAXDURATION) {
 $PAGEUSAGE_MAXDURATION_EXCEEDED = true;
 }
 return $count;
 }

 
 $sql = get_usageinfo_sql($T_PAGE . '_PAGETAGS', $objs, $T_PAGE);
 $res = query($sql);
 $count += $res["num"];
 
 $sql = get_usageinfo_sql($T_TEMPLATE . "_PAGETAGS", $objs, $T_TEMPLATE);
 $res = query($sql);
 $count += $res["num"];
 
 $USAGE_PAGEUSAGE = $usage_pageusage_oldvalue;
 if ((microtime_float() - $start) > $PAGEUSAGE_MAXDURATION) {
 $PAGEUSAGE_MAXDURATION_EXCEEDED = true;
 }
 return $count;
}

function microtime_float() {
 list($usec, $sec) = explode(" ", microtime());
 return ((float)$usec + (float)$sec);
}

?>
