<?php



class IconFormatter extends ResultsetFormatter {
 var $colname;

 function IconFormatter( $colname ) {
 $this->colname = $colname;
 }
 function format( $row ) {
 global $invalid_tags;
 return img( tag_icon( $row[$this->colname] ), 0, $row['enabled']?i18n('Visible'):i18n('Invisible'), '', '', '', '', '', ($row['enabled']?NULL:'gentics_icon_invisible') );
 
 }
}

class ActionsFormatter extends ResultsetFormatter {
 function format( $row ) {
 if($row['intag']) {
 global $ICO_DELETE,$STAG,$DO;
 return '<a href="'.$STAG.'&do='.$DO.'&cmd=del&tag_id='.$row['id'].'">'.img($ICO_DELETE, 0, i18n('Delete')).'</a>';
 }
 return '';
 }
}

class ConstructNameFormatter extends ResultsetFormatter {

 function ConstructNameFormatter( ) {
 }

 function format( $row ) {
 global $CONSTRUCTS;
 return $CONSTRUCTS[$row['construct_id']];
 }
}

class NameFormatter extends ResultsetFormatter {
 function NameFormatter( ) {
 }
 function format( $row ) {
 global $OBJPROP_NEW_EDIT_ID, $invalid_tags, $onlylist, $OBJPROP_NEW_DOERRORCHECK;
 $style = '';
 if($invalid_tags[$row['name']] && ($OBJPROP_NEW_DOERRORCHECK || $invalid_tags[$row['name']] !== true)) {
 $style = 'color:red;';
 
 }
 if( $style ) $style = " style=\"$style\"";
 $title = '';
 if( $row['description'] ) {
 $title = ' title="' . $row['description'] . '"';
 }
 $val = $row['readablename'] ? $row['readablename'] : $row['name'];
 if(!$onlylist && $OBJPROP_NEW_EDIT_ID == $row['id'])
 return '<b'.$style.$title.'>'.$val.'</b>';
 return "<span $style $title>$val</span>";
 }
}

class ErrorFormatter extends ResultsetFormatter {
 function ErrorFormatter() {
 }
 function format( $row ) {
 global $invalid_tags;
 return $invalid_tags[$row['name']];
 }
}

class AllowEditFormatter extends ResultsetFormatter {
 function AllowEditFormatter( ) {
 }
 function format( $row ) {
 return true;
 
 
 
 
 }
}



$OBJPROP_EDIT_NOPERM_ERRORS = 0;
class PermissionFilter extends SQLDatasourceFilter {
 function PermissionFilter() {
 }
 function checkRow( $row ) {
 global $OBJPROP_EDIT_NOPERM_ERRORS, $invalid_tags;
 $r = checkpermbit( $row, 0 );
 if(!$r && $invalid_tags[ $row['name'] ]) {
 $OBJPROP_EDIT_NOPERM_ERRORS++;
 }
 return $r;
 }
}

class RequiredFormatter extends ResultsetFormatter {
 function format( $row ) {
 global $editable, $STAG_PREFIX;
 $r = '';
 if( $row['objrequired'] ) {
 $r .= img( $STAG_PREFIX.'?do=11&module=system&img=required.gif', 0, i18n('Required') );
 }
 if( !$editable || !checkpermbit( $row, 2 ) ) {
 $r .= img( $STAG_PREFIX.'?do=11&module=system&img=readonly.gif', 0, i18n('Read Only') );
 }
 return $r;
 }
}

class ReadonlyFormatter extends ResultsetFormatter {
 function format( $row ) {
 global $editable;
 return !( $editable && checkpermbit( $row, 2 ) );
 }
}
