<?php


class ScheduleType
{
 function buildForm( $jobId = 0 ){}
 function getName() {}
 function getShortSummary() {}
 
 






 function getRelations() {}
 
 





 function loadGlobals() {}
 
 




 function getData() {}
 
 







 function loadData( $data ) {}
 
 






 function setGlobals() {}
 









 function isDue( $time, $lastrun, $jobId, $previousJobIds ) {} 
 
 






 function start() {}
 






 function finished() {}
 
 









 function isDone( $time, $lastRun, $id, $previousJobs ) {} 
 
 




 function getActions() {}
 





 function performAction( $action ) {}
}


class ScheduleTypeTime extends ScheduleType
{
 var $d_timeStamp, $d_runNext;

 function buildForm( $jobId = 0 )
 {
 global $HI, $DIC;
 
 $f = $HI["date"];
 $f["label"] = i18n('date');
 $f["var"] = "sDate";
 $hi[] = $f;
 $f = $HI["time"];
 $f["label"] = i18n('1195.time');
 $f["var"] = "sTime";
 $hi[] = $f;
 
 return $hi;
 }
 
 function isDue( $time, $lastRun, $jobId, $previousJobIds )
 {
 if ( $this->d_runNext )
 return true;
 return $time > $this->d_timeStamp && !$lastRun;
 }
 
 function getName()
 {
 global $DIC;
 return i18n('point_in_time');
 }
 
 function getShortSummary() 
 {
 return date( "d-m-Y H:i", $this->d_timeStamp );
 }
 
 function setGlobals()
 {
 global $sDate, $sTime;
 $sDate = $sTime = $this->d_timeStamp;
 }
 
 function loadData( $data )
 {
 $this->d_timeStamp = $data["timeStamp"];
 $this->d_runNext = $data["runnext"];
 }
 

 function loadGlobals()
 {
 global $sDate, $sTime;
 node_include( "datestring2ts" );
 $this->d_timeStamp = merge_date_time( $sDate, $sTime );
 }

 function getData()
 {
 node_include( "datestring2ts" );
 $data = array(
 "timeStamp" => $this->d_timeStamp,
 "runnext" => $this->d_runNext
 );
 return $data;
 }

 function isDone( $time, $lastRun, $id, $previousJobs ) 
 {
 if ( $this->d_runNext )
 return false;
 return $lastRun != 0;
 }


 function getActions()
 { 
 global $DIC;

 if (perm($USER_ID, T_TASKADMIN, "", 13)) {
 return array(
 array( "key"=>"runnow", "descr"=>i18n('sn_task_run_now') )
 );
 } else {
 return array();
 }
 }


 function performAction( $action )
 { 
 switch ( $action )
 { 
 case "runnow":
 $this->d_runNext = true;
 break;
 }
 }

 function finished()
 { 
 if ( $this->d_runNext )
 $this->d_runNext = false;
 }


}

class ScheduleTypeInterval extends ScheduleType
{
 var $d_start, $d_end, $d_every,$d_scale, $d_runNext;
 
 function buildForm( $jobId = 0 )
 {
 global $HI, $DIC;
 
 $f = $HI["date"];
 $f["label"] = i18n('startdate');
 $f["optional"] = true;
 $f["var"] = "sStartDate";
 $hi[] = $f;
 $f = $HI["time"];
 $f["label"] = i18n('sn_starttime');
 $f["optional"] = true;
 $f["allow_empty"] = true;
 $f["var"] = "sStartTime";
 $f["nobreak"] = true;
 $hi[] = $f;
 $f = $HI["date"];
 $f["label"] = i18n('enddate');
 $f["optional"] = true;
 $f["allow_empty"] = true;
 $f["var"] = "sEndDate";
 $hi[] = $f;
 $f = $HI["time"];
 $f["label"] = i18n('sn_endtime');
 $f["optional"] = true;
 $f["allow_empty"] = true;
 $f["var"] = "sEndTime";
 $f["nobreak"] = true;
 $hi[] = $f;
 
 $f = $HI["int"];
 $f["label"] = i18n('415.all');
 $f["var"] = "sEvery";
 $f["size"] = 5;
 $hi[] = $f;
 
 $f = $HI["sel"];
 $f["label"] = "";
 $f["var"] = "sScale";
 $f["nobreak"] = true;
 $f["list"] = array( "min"=>i18n('minutes'), "std"=>i18n('hours'), "day"=>i18n('sn_days') );
 $hi[] = $f;
 
 return $hi;
 }

 function _translateScale( $long = false )
 {
 global $DIC;

 switch ( $this->d_scale )
 {
 case "min":
 return $long?i18n('minutes'):i18n('sn_minutes_short');
 case "std":
 return $long?i18n('hours'):i18n('tn_hours_short');
 case "day":
 return $long?i18n('sn_days'):i18n('sn_days_short');
 }
 }
 
 function getInterval()
 {
 switch ( $this->d_scale )
 {
 case "min":
 $int = 60 * $this->d_every;
 break;
 case "std":
 $int = 60*60 * $this->d_every;
 break;
 case "day":
 $int = 24*60*60 * $this->d_every;
 break;
 case "month":
 halt( 7, "TODO: isDue for months!!!!" );
 break;
 }
 return $int;
 }
 
 function isDone( $time, $lastRun, $id, $previousJobs ) 
 {
 if ( $this->d_runNext )
 return false;
 if ( !$this->d_end )
 return false;
 return $lastRun+$this->getInterval() >= $this->d_end || $time >= $this->d_end;
 }
 
 









 function _getMostRecentSchedule($time) {
 $interval = $this->getInterval();
 if ($interval <= 0) {
 return false;
 }
 if ($this->d_scale == "day") {
 
 
 
 
 
 
 
 
 
 
 
 

 
 $days = floor(($time - $this->d_start) / (60*60*24));
 
 if (strtotime("+".$days." days", $this->d_start) > $time) {
 
 
 
 $days--;
 } elseif (strtotime("+".($days+1)." days", $this->d_start) <= $time) {
 
 
 
 $days++;
 }
 
 
 $number_of_runs = floor($days / $this->d_every);
 
 $days_until_recent_schedule = $number_of_runs * $this->d_every;
 
 
 return strtotime("+$days_until_recent_schedule days", $this->d_start);
 } else {
 return $this->d_start + 
 (intval(($time - $this->d_start) / $interval) * $interval);
 }
 }

 function isDue( $time, $lastRun, $jobId, $previousJobIds ) {
 if ( $this->d_runNext ) {
 return true;
 }
 if ( $this->isDone($time, $lastRun, $jobId, $previousJobIds) ) {
 return false;
 }

 
 if ( $time < $this->d_start ) {
 return false;
 }

 $mostRecent = $this->_getMostRecentSchedule($time);
 if ($mostRecent === false) {
 return false;
 }
 return $lastRun < $mostRecent;
 }
 
 
 function finished()
 {
 if ( $this->d_runNext )
 $this->d_runNext = false;
 }
 
 function getActions() 
 {
 global $DIC;

 return array(
 array( "key"=>"runnow", "descr"=>i18n('sn_task_run_now') )
 );
 }

 function performAction( $action )
 {
 switch ( $action )
 {
 case "runnow":
 $this->d_runNext = true;
 break;
 }
 } 

 function getShortSummary() 
 {
 global $DIC; 

 $str = "<table border=0>";
 $str .= "<tr><td><b>".i18n('from').":</b></td><td>".date( "d-m-Y H:i", $this->d_start )."</td></tr>";
 $str .= "<tr><td><B>".i18n('until').":</b></td><td>".($this->d_end?date( "d-m-Y H:i", $this->d_end ):i18n("No limit"))."</td></tr>";
 $str .= "<tr><td>".i18n('415.all')." </td><td>".$this->d_every." ".$this->_translateScale()."</td></tr>";
 $str .= "</table>";
 return $str;
 }

 
 function getName()
 {
 global $DIC;
 return i18n('sn_interval');
 }
 
 function setGlobals( )
 {
 global $sStartDate, $sStartTime, $sEndDate, $sEndTime, $sEvery, $sScale;
 $sStartDate = $sStartTime = $this->d_start;
 $sEndDate = $sEndTime = $this->d_end;
 $sEvery = $this->d_every;
 $sScale = $this->d_scale;
 }
 
 function loadData( $data )
 {
 $this->d_start = $data["start"];
 $this->d_end = $data["end"];
 $this->d_every = $data["every"];
 $this->d_scale = $data["scale"];
 $this->d_runNext = $data["runnext"];
 }
 
 function loadGlobals()
 {
 global $sStartDate, $sStartTime, $sEndDate, $sEndTime, $sEvery, $sScale;
 node_include( "datestring2ts" );
 if ( !$sStartTime ) {
 $sStartTime = mktime( 0,0,0 ); 
 }
 if ( !$sEndDate && !$sEndTime )
 $end = 0; 
 else {
 if ( !$sEndDate ) $sEndDate = time();
 else if ( !$sEndTime ) $sEndTime = mktime( 0,0,0 ); 
 $end = merge_date_time( $sEndDate, $sEndTime );
 }
 
 $data = array(
 "start" => merge_date_time( $sStartDate, $sStartTime ),
 "end" => $end,
 "every" => $sEvery,
 "scale" => $sScale,
 );
 $this->d_start = $data["start"];
 $this->d_end = $data["end"];
 $this->d_every = $data["every"];
 $this->d_scale = $data["scale"];
 }
 
 function getData()
 {
 node_include( "datestring2ts" );
 $data = array(
 "start" => $this->d_start,
 "end" => $this->d_end,
 "every" => $this->d_every,
 "scale" => $this->d_scale,
 "runnext" => $this->d_runNext
 );
 return $data;
 }
}

class ScheduleTypeFollowup extends ScheduleType
{
 var $d_followJobs, $d_jobTable = NULL, $d_runNext = false, $d_onSuccess = false;

 function &_getJobTable()
 {
 node_class( "sqltable" );
 if ( $this->d_jobTable != NULL )
 return $this->d_jobTable;
 return new SqlTable( "job" );
 }

 





 function buildForm($jobId = 0) {
 global $HI, $DIC;
 $joblist = array();
 
 $depJobs = $this->getDependendJobs($jobId);
 if (count($depJobs) == 0) {
 $depJobs = array(-1);
 }

 
 
 
 $sql = "SELECT j.id, j.name FROM job j LEFT JOIN jobdependency jd ON j.id = jd.jobid " . " WHERE jd.jobid NOT IN (" . implode(',', sqlf_tl_num_array($depJobs)) . ") OR jd.depid IS NULL GROUP BY j.id";
 $res = query($sql);
 if ($res['num'] > 0) {
 $jobs = $res['arr'];
 foreach ($jobs as $job) {
 
 if ($job['id'] != $jobId) {
 $joblist[$job['id']] = $job['name'];
 }
 }
 }
 
 $f = $HI["sel"];
 $f["force"] = false;
 $f["label"] = i18n('task job');
 $f["help"] = i18n('task_job_help');
 $f["var"] = "sJob";
 $f["size"] = 5;
 $f["multiple"] = TRUE;
 $f["list"] = $joblist;
 $hi[] = $f;
 
 $f = $HI["checkbox"];
 $f["var"] = "scheduleTypeFollowupOnSuccess";
 $f["label"] = i18n("Follow on success");
 $f["help"] = i18n("Only run if the preceding task exits successfully.");
 $hi[] = $f;

 return $hi;
 }

 






 function getDependendJobs($jobId, $maxDepth = 50) {
 if (! $jobId) {
 return array();
 }
 $allDependendJobs = array();
 return $this->_getDependendJobs($jobId, $allDependendJobs, 0, $maxDepth);
 }

 








 function _getDependendJobs($jobId, &$allDependendJobs, $depth = 0, $maxDepth) {
 if ($depth >= $maxDepth) {
 return array();
 }
 if (! $jobId) {
 return array();
 }
 $sql = "SELECT jobid FROM jobdependency j where j.depid = " . sqlf_tl_num($jobId);
 $res = query($sql);
 if ($res['num'] > 0) {
 foreach ($res['arr'] as $k => $v) {
 
 if (! in_array($v['jobid'], $allDependendJobs)) {
 $allDependendJobs[] = $v['jobid'];
 $this->_getDependendJobs($v['jobid'], $allDependendJobs, $depth + 1, $maxDepth);
 }
 }
 }
 return $allDependendJobs;
 }

 




 function getJobAncestors($jobId) {
 if (!$jobId) {
 return array();
 }
 $res = query("SELECT depid FROM jobdependency j where j.jobid = ".sqlf_tl_num($jobId));
 $ancestors = array();
 if ($res['num'] > 0) {
 foreach ($res['arr'] as $k => $v) {
 $ancestors[] = $v['depid'];






 }
 }
 return $ancestors;
 }
 
 function isDone( $time, $lastRun, $id, $previousJobs ) 
 {
 if ( $this->d_runNext )
 return false;
 node_class( "sqltable" );
 $jobTable = new SqlTable( "job" );
 $jobs = $jobTable->findBy( "id", $this->d_followJobs );
 if ( $jobs[0] )
 {
 $status = getJobStatus( $jobs[0], false, array_merge( $previousJobs, array( $id ) ) );
 if ( $status == JOBSTATUS_INVALID ) return true;
 }
 else
 return TRUE;

 return $status == JOBSTATUS_DONE; 
 }


 function isDue( $time, $lastRun, $jobId, $previousJobIds )
 {
 if ( $this->d_runNext )
 return TRUE;
 
 if ( !count($previousJobIds) )
 return false;
 $ret = false;
 foreach ( $previousJobIds as $pJob )
 {
 if ( in_array( $pJob, $this->d_followJobs ) )
 {
 $ret = true;
 }
 else if ( $pJob == $jobId )
 {
 $ret = false;
 }
 }
 return $ret;
 }
 
 function finished()
 {
 if ( $this->d_runNext )
 $this->d_runNext = false;
 }
 
 function getActions() 
 {
 global $DIC;

 return array(
 array( "key"=>"runnow", "descr"=>i18n('sn_task_run_now') )
 );
 }

 function performAction( $action )
 {
 switch ( $action )
 {
 case "runnow":
 $this->d_runNext = true;
 break;
 }
 } 
 
 function getRelations()
 {
 return $this->d_followJobs;
 }
 
 function getName()
 {
 global $DIC;
 return i18n('sn_task_terminate_descr');
 }
 
 function getShortSummary()
 {
 global $DIC;
 $jobTable = $this->_getJobTable();
 
 $jobs = $jobTable->findBy( "id", $this->d_followJobs, "IN", false, false, true );
 
 $ret = array();
 foreach ( $jobs as $job )
 {
 $ret[] = $job->getValue( "name" );
 }
 return i18n('sn_after').": " . implode( ", ", $ret );
 }
 
 function setGlobals()
 {
 global $sJob, $scheduleTypeFollowupOnSuccess;
 $sJob = $this->d_followJobs;
 $scheduleTypeFollowupOnSuccess = $this->d_onSuccess;
 }
 
 function loadData( $data )
 {
 $this->d_followJobs = $data["jobs"];
 $this->d_runNext = $data["runnext"];
 $this->d_onSuccess = !!$data["onSuccess"];
 }
 
 function loadGlobals()
 {
 global $sJob, $scheduleTypeFollowupOnSuccess;
 $this->d_followJobs = $sJob;
 $this->d_onSuccess = $scheduleTypeFollowupOnSuccess;
 }
 
 function getData()
 {
 return array("jobs"=>$this->d_followJobs, "runnext"=>$this->d_runNext, "onSuccess" => $this->d_onSuccess); 
 }

 






 function doesFollowupOnSuccess() {
 return $this->d_onSuccess;
 }
}


class ScheduleTypeManual extends ScheduleType
{
 var $d_runNext = false;
 
 function buildForm( $jobId = 0 )
 {
 return array();
 }

 function isDone( $time, $lastRun, $id, $previousJobs ) 
 {
 return false;
 }
 
 
 function isDue( $time, $lastRun, $jobId, $previousJobIds )
 {
 return $this->d_runNext;
 }
 
 
 function finished()
 {
 $this->d_runNext = false;
 }
 
 function getActions() 
 {
 global $DIC;

 return array(
 array( "key"=>"runnow", "descr"=>i18n('sn_task_run_now') )
 );
 }

 function performAction( $action )
 {
 switch ( $action )
 {
 case "runnow":
 $this->d_runNext = true;
 break;
 }
 } 
 
 function getName()
 {
 global $DIC;
 return i18n('sn_manual');
 }
 
 function loadData( $data )
 {
 $this->d_runNext = $data;
 }
 
 function getData()
 {
 return $this->d_runNext;
 }

 function getShortSummary() {
 return $this->getName();
 }
}

global $scheduleTypeClasses;
$scheduleTypeClasses = array(
 "time" => new ScheduleTypeTime(),
 "int" => new ScheduleTypeInterval(),
 "followup" => new ScheduleTypeFollowup(),
 "manual" => new ScheduleTypeManual()
);


?>
